poj 3126 prime path(bfs)

来源:互联网 发布:苏州seo外包 编辑:程序博客网 时间:2024/06/05 06:55

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

题意,每次只能换一个数字,而且要保证每一步得出的结果都是素数,先打个表,再bfs,水题。

#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <queue>using namespace std;int n1,n2;struct node{    int num,step;    bool operator <(const node&rhs) const    {        return step>rhs.step;    }};int prime[20050];priority_queue <node> que;int vis[11][11][11][11];int bfs(){    while(!que.empty())    {        node head;        head=que.top();        int x=head.num;        int ss=head.step;        que.pop();        // printf("%d\n",x );        int xx=0;        for(int i=1;i<=9;i++)        {            xx=x%1000+i*1000;            // printf("%d\n",xx ); getchar();            if(!vis[xx/1000][xx/100%10][xx/10%10][xx%10]&&!prime[xx])            {                que.push(node{xx,ss+1});                vis[xx/1000][xx/100%10][xx/10%10][xx%10]=1;                if(xx==n2) return ss+1;            }        }        for(int i=0;i<=9;i++)        {            xx=x/1000*1000+i*100+x%100;            // printf("%d\n",xx ); getchar();            if(!vis[xx/1000][xx/100%10][xx/10%10][xx%10]&&!prime[xx])            {                que.push(node{xx,ss+1});                vis[xx/1000][xx/100%10][xx/10%10][xx%10]=1;                if(xx==n2) return ss+1;            }        }        for(int i=0;i<=9;i++)        {            xx=x/100*100+i*10+x%10;            // printf("%d\n",xx ); getchar();            if(!vis[xx/1000][xx/100%10][xx/10%10][xx%10]&&!prime[xx])            {                que.push(node{xx,ss+1});                vis[xx/1000][xx/100%10][xx/10%10][xx%10]=1;                if(xx==n2) return ss+1;            }        }        for(int i=0;i<=9;i++)        {            if(i%2)            {                xx=x/10*10+i;                // printf("%d\n",xx ); getchar();            if(!vis[xx/1000][xx/100%10][xx/10%10][xx%10]&&!prime[xx])            {                que.push(node{xx,ss+1});                vis[xx/1000][xx/100%10][xx/10%10][xx%10]=1;                if(xx==n2) return ss+1;            }            }        }    }}int main(){    memset(prime,0,sizeof(prime));    for(int i=2;i<=20000;i++)    {        if(!prime[i])        for(int j=i*2;j<=20000;j+=i)        {            prime[j]=1;        }    }    int t;    cin>>t;    while(t--)    {        cin>>n1>>n2;        while(!que.empty()) que.pop();        memset(vis,0,sizeof(vis));        if(n1==n2) printf("0\n");        else        {            vis[n1/1000][n1/100%10][n1/10%10][n1%10]=1;            que.push(node{n1,0});            printf("%d\n",bfs());        }    }}
0 0
原创粉丝点击